// ExDac.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include "ExDac.h"

#include "Measure.H"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Beachten Sie!
//
//		Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//		muss bei allen von dieser DLL exportierten Funktionen,
//		die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//		direkt am Beginn der Funktion eingefgt sein.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//		// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//		als erste Anweisung innerhalb der Funktion ausgefhrt werden
//		muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe MFC Technical Notes 33 und 58 fr weitere
//		Details.
//

/////////////////////////////////////////////////////////////////////////////
// CExDacApp

BEGIN_MESSAGE_MAP(CExDacApp, CWinApp)
	//{{AFX_MSG_MAP(CExDacApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExDacApp Konstruktion

CExDacApp::CExDacApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CExDacApp-Objekt

CExDacApp theApp;



// global variable
CMeasurement* g_pMeasure;
CRITICAL_SECTION g_CriticalSection;



/******************************************************************************
*								CExDacApp::InitInstance
*	PURPOSE
*	REMARK
*	PARAMETER
*	RETURN
*	HISTORY
******************************************************************************/
BOOL CExDacApp::InitInstance() 
{
	// TODO: Speziellen Code hier einfgen und/oder Basisklasse aufrufen

    g_pMeasure = NULL;
    
	return CWinApp::InitInstance();
}



/******************************************************************************
*                   InitMeasurement
*   PUPROSE
*   REMARK
*   PARAMETER
*   RETURN
*   HISTORY
******************************************************************************/
extern "C" __declspec(dllexport) unsigned long _stdcall InitMeasurement(ULONG ulBoardNumber, ULONG ulXmax1Slot, ULONG ulXad1420Slot, ULONG ulNumberOfData, double dFrequency)
{
    ULONG ulError;

    // init critical section object
    InitializeCriticalSection(&g_CriticalSection);

    // delete old measure object
    if (g_pMeasure != NULL)
    {
        delete(g_pMeasure);
    }

    // create new measurement object
    g_pMeasure = new CMeasurement(ulBoardNumber, ulXmax1Slot, ulXad1420Slot, ulNumberOfData, dFrequency);

    // call init function
    ulError = g_pMeasure->Init();

    return ulError;
}



/******************************************************************************
*                   ReadAin
*   PUPROSE
*   REMARK
*   PARAMETER
*   RETURN
*   HISTORY
******************************************************************************/
extern "C" __declspec(dllexport) unsigned long _stdcall ReadAin(ULONG ulChannelIndex, LONG* plData, ULONG* pulDataIndex)
{
    ULONG ulReturn;

    EnterCriticalSection(&g_CriticalSection);

    if (g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].ulFree != g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].ulSize)
    {
        *plData = g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].prcRead->lData;
        *pulDataIndex = g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].prcRead->ulIndex;
        g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].ulFree++;
        g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].prcRead++;
        if ( (g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].prcEnd-g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].prcRead) <= 0 )
        {
            g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].prcRead = g_pMeasure->m_arcPcAinBuffer[ulChannelIndex].prcStart;
        }

        ulReturn = 0;
    }
    else
    {
        ulReturn =  ERR_EXDAC_NO_DATA;
    }

    LeaveCriticalSection(&g_CriticalSection);

    return ulReturn;
}



/******************************************************************************
*                   MeasurementService
*   PUPROSE
*   REMARK
*   PARAMETER
*   RETURN
*   HISTORY
******************************************************************************/
MAX_CALLBACK MeasurementService(MAXMODHND hModul, ULONG ulMessage)
{
    MAX_ERROR Error;
    ULONG ulBuffer, ulIndex, ulSize, i, j;
    BOOL bClearOsXBufferComplete;
    OSX_BUFFER_DATA     arcOsXBufferData[1000];               // buffer for reading OsX buffer

    EnterCriticalSection(&g_CriticalSection);

    // check srq
    if (ulMessage == SRQ_FINISHED)
    {
        TRACE ("SRQ_FINISHED\r\n");
        bClearOsXBufferComplete = TRUE;
    }
    else if (ulMessage == SRQ_DATA_READY)
    {
        TRACE ("SRQ_DATA_READY\r\n");
        bClearOsXBufferComplete = FALSE;
    }
    else
    {
        TRACE ("SRQ_???\r\n");
        // stop measurement
        Error = max_call_proc(g_pMeasure->m_rcXmax1.hModule, g_pMeasure->m_rcRtProgram.usTask, 4);
    }


    do
    {
        // get data from OsX buffer
        ulSize = 1000*sizeof(OSX_BUFFER_DATA);
        ulBuffer = ulSize;
        Error = max_get_buffer(g_pMeasure->m_rcOsXBuffer.hBufHandle, MAX_BUFFER_MOVE_MAX, &ulSize, &arcOsXBufferData);


        /////////////////////////////////////////////
        // write data into PC buffer
        /////////////////////////////////////////////
        ulIndex = ulSize / sizeof(OSX_BUFFER_DATA);     // calculate number of data records (AIN0, AIN1, DIN)
        TRACE ("Number Of Data %lu\r\n", ulIndex);
        for (i=0; i<ulIndex; i++)
        {
            // AIN
            /////////////////////////////////////////////////////////////
            for (j=0; j<2; j++)
            {
                if (g_pMeasure->m_arcPcAinBuffer[j].ulFree != 0)
                {
                    g_pMeasure->m_arcPcAinBuffer[j].prcWrite->lData = arcOsXBufferData[i].alAin[j];
                    g_pMeasure->m_arcPcAinBuffer[j].prcWrite->ulIndex = g_pMeasure->m_arcPcAinBuffer[j].ulIndex++;
                    g_pMeasure->m_arcPcAinBuffer[j].prcWrite++;
                    g_pMeasure->m_arcPcAinBuffer[j].ulFree--;
                }
                else
                {
                    g_pMeasure->m_arcPcAinBuffer[j].ulError = ERROR_PC_BUFFER_OVERRUN;
                }
                if ( (g_pMeasure->m_arcPcAinBuffer[j].prcEnd-g_pMeasure->m_arcPcAinBuffer[j].prcWrite) <= 0 )
                {
                    g_pMeasure->m_arcPcAinBuffer[j].prcWrite = g_pMeasure->m_arcPcAinBuffer[j].prcStart;
                }
            }
            /////////////////////////////////////////////////////////////
        }

    } while ( (ulSize == ulBuffer) && (bClearOsXBufferComplete == TRUE) );

    LeaveCriticalSection(&g_CriticalSection);
}




int CExDacApp::ExitInstance() 
{
	// TODO: Speziellen Code hier einfgen und/oder Basisklasse aufrufen
	
    // delete measure object
    if (g_pMeasure != NULL)
    {
        delete(g_pMeasure);
    }

	return CWinApp::ExitInstance();
}
