/****************************************************************************/
// EXDAC
//
// Interface between the exdac.exe realtime-program and the master-DLL
//
// (C)2002 SORCUS Computer GmbH
/****************************************************************************/

#include "max_lib.h"
#include "x_error.h"
#include "x_mdd.h"

// program number of the exdac.exe realtime program
#define EXDAC_PROG_NO           0x9008

// SRQ words used in communication between X-MAX-1 and host
#define SRQ_FINISHED            0x8090
#define SRQ_DATA_READY          0x8091
#define SRQ_ERROR               0x8092

#define ERR_EXDAC           1
#define ERR_EXDAC_NO_DATA   2
#define ERROR_PC_BUFFER_OVERRUN     1


// all structs are word aligned
#ifndef _RTLIB_
   #pragma pack(push, SORCPACK, 2)
#endif

// data struct expected by function 2 of the realtime program
typedef struct
{
   USHORT      usADSlot;			// slot number of the X-AD14-20
   // performance parameter
   USHORT	   usTimeValue;		    // for acquisition frequency: 1 = 0,84us
   ULONG       ulBufferID;    	    // ID for used OsX buffer
   ULONG	   ulAcquisitions;	    // number of data acquisitions cycles (0=infinite)
} DAQ_INIT_DATA;

typedef struct
{
	long	alAin[2];
} OSX_BUFFER_DATA;

#ifndef _RTLIB_
   #pragma pack(pop, SORCPACK)
#endif
