VERSION 5.00
Begin VB.Form MddSample 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Sample program: Data aquisition with X-AD14-20"
   ClientHeight    =   2865
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5865
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2863.969
   ScaleMode       =   0  'Benutzerdefiniert
   ScaleWidth      =   5865
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox DataBox 
      Height          =   1455
      Left            =   1800
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   3
      Text            =   "mddsample.frx":0000
      Top             =   1200
      Width           =   2295
   End
   Begin VB.CommandButton MeasureButton 
      Caption         =   "Measure"
      Enabled         =   0   'False
      Height          =   1455
      Left            =   240
      TabIndex        =   2
      Top             =   1200
      Width           =   1335
   End
   Begin VB.TextBox InfoBox 
      Enabled         =   0   'False
      Height          =   735
      Left            =   1800
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   120
      Width           =   3855
   End
   Begin VB.CommandButton InitButton 
      Caption         =   "Init"
      Height          =   735
      Left            =   960
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   240
      Picture         =   "mddsample.frx":0015
      Top             =   240
      Width           =   480
   End
End
Attribute VB_Name = "MddSample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'****************************************************************************'
'*                                                                          *'
'* Sample for usage of a MAX6pci as non-intelligent board.                  *'
'*                                                                          *'
'* The program demonstrates how to initialize the board                     *'
'*                          how to load a PC-based Module-Device-Driver     *'
'*                          how to open a MDD channel                       *'
'*                          how to read analog values from the channel      *'
'*                                                                          *'
'* If the data acquisition performance is not fast enough or not the        */'
'* real time capability is insufficent, plug a X-MAX-1 CPU module onto      */'
'* the board and see the sample buf_dacq                                    */'
'*                                                                          */'
'* Copyright SORCUS Computer GmbH 2001                                      */'
'****************************************************************************'

Dim hAin As Long                ' handle for the analog input channel

' internal helper function to display error messages
Private Sub ErrorHandler(ByVal Error As Integer, ByVal source As String)
    Dim usMsgSize As Integer
    Dim sMsgText As String
    Dim sTitle As String
    Dim sErrMsg As String * 100 ' provide enough memory space
                                ' where max_get_error_message can write to
    usMsgSize = 100             ' max size of message text
    Call max_get_error_message(Error, usMsgSize, sErrMsg)
    sMsgText = "Error " & Format(Hex(Error), "0000") & "h : " & sErrMsg
    sTitle = "Error calling function " & source
    Error = MsgBox(sMsgText, vbExclamation, sTitle)
    Call max_clear_error
    
End Sub

Private Sub InitButton_Click()

    Dim usBoardNr As Integer        ' number given in the setup-tool
                                    ' (see 'All SORCUS Boards' in the Windows control panel)
    Dim Error As Integer
    Dim Version As Long
    Dim ulDate As Long
    Dim szVersion As String * 16
    Dim szDate As String * 16
    Dim usADSlot As Integer
    Dim usADLayer As Integer
    Dim prcOs As MAX_OS_INFO
    Dim prcMddProgram As MAX_PGM_TYPE
    Dim hMdd As Long
    Dim hModul As Long
    Dim rcChannelCfg As CPS_XAD1420
    
    usBoardNr = 1
    usADSlot = 1            ' where the X-AD14-20 is pluged in
    usADLayer = 0

    ' Init library
    Error = max_init_lib(0)
    If Error <> ERR_OK Then
       Call ErrorHandler(Error, "max_init_lib")
       Exit Sub
    End If

    ' get version information
    Call max_get_lib_version(Version, ulDate)
    Call max_get_version_string(Version, ulDate, szVersion, szDate)
    InfoBox.Text = "MAXW32.DLL-Library Version: " & szVersion
    InfoBox.Text = InfoBox.Text & ", " & szDate & vbCrLf
    InfoBox.Text = InfoBox.Text & vbCrLf
    Error = max_get_drv_version(Version, ulDate)
    If Error <> ERR_OK Then
        Call ErrorHandler(Error, "max_get_drv_version")
    Else
        Call max_get_version_string(Version, ulDate, szVersion, szDate)
        InfoBox.Text = InfoBox.Text & "MAXNT4.SYS-Driver Version: " & szVersion
        InfoBox.Text = InfoBox.Text & ", " & szDate
        InfoBox.Text = InfoBox.Text & vbCrLf
    End If

    ' reset the board
    Error = max_reset_board(usBoardNr, 10)
    If Error <> ERR_OK Then
        Call ErrorHandler(Error, "max_reset_board")
        Exit Sub
    End If
    
    ' get a CPU handle. When working without CPU-module connect to windows CPU.
    ' prcOs does not return data if there is no CPU module
    Error = max_connect_cpu(usBoardNr, 0, 0, prcOs, hModul)
    If Error <> ERR_OK Then
        Call ErrorHandler(Error, "max_connect_cpu")
        Exit Sub
    End If
   
    ' load MDD for X-AD14-20
    ' prcMddProgram does not need initialization if usProgNo is not 0
    Error = max_load_mdd(hModul, usADSlot, usADLayer, 0, MDD_X_AD14_20, _
                         prcMddProgram, hMdd)
    If Error <> ERR_OK Then
        Call ErrorHandler(Error, "max_load_mdd")
        Exit Sub
    End If
    
    ' display version info about the loaded MDD
    Error = max_get_mdd_version(hMdd, Version, ulDate)
    Call max_get_version_string(Version, ulDate, szVersion, szDate)
    InfoBox.Text = InfoBox.Text & "MDD for X-AD14-20 Version: " & szVersion
    InfoBox.Text = InfoBox.Text & ", " & szDate
    InfoBox.Text = InfoBox.Text & vbCrLf
    
    ' open a channel to AIN 0
    rcChannelCfg.usDevice = DEVICE_AIN_DIFF
    rcChannelCfg.usIndexFirst = 0
    rcChannelCfg.usIndexLast = 0
    rcChannelCfg.usFlags = CP_UNCORRECTED
    rcChannelCfg.usReadMode = IO_MODE_DIRECT
    rcChannelCfg.usRange = RANGE_BIP_10V
    rcChannelCfg.usSettleTime = 1
    Error = max_open_channel(hMdd, Sizeof_CPS_XAD1420, rcChannelCfg, 0, 0, hAin)
    If Error <> ERR_OK Then
        Call ErrorHandler(Error, "max_open_channel")
        Exit Sub
    End If
   
    MeasureButton.Enabled = True
    InitButton.Enabled = False
   
End Sub

' Read analog input channel
Private Sub MeasureButton_Click()
    Dim lData As Long
    Dim Error As Integer
    
    Error = max_read_channel_long(hAin, lData)
    If Error <> ERR_OK Then
        Call ErrorHandler(Error, "max_read_channel_long")
    Else
        DataBox.Text = DataBox.Text & vbCrLf & Format(lData / 1000000, "0.000")
        DataBox.Text = DataBox.Text & " V"
    End If
End Sub
