#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <windows.h>
#include "max_lib.h"
#include "../minican.h"

#define ONE_INTERFACE 1


int main()
{
	MAX_ERROR Error;
	CHAR acError[80];		//string for error messages
	USHORT nELength = 80;	//length of error string
	MAXMODHND hCPUModule;
	MAX_OS_INFO os;
	USHORT card, CPUslot, CANslot;
	USHORT usInSize, usOutSize, usSlot, usCount;
	CAN_INTERFACE_PARAMETERS rcCanParams;
	CAN_INTERFACE_WRITE rcWriteMsg;
	CAN_INTERFACE_READ arcReadMsg[5];
	int i,j;

	//////////////////////////////////////////
	//set this according to your configuration
	card		= 0;
	CPUslot		= 1;
	CANslot		= 6;
	//////////////////////////////////////////

	Error = max_init_lib(0);

	//connect to the CPU module
	Error = max_connect_cpu(card, CPUslot, 0, &os, &hCPUModule);
	if (Error != ERR_OK)
	{
		max_clear_error();
		nELength = sizeof(acError);
		max_get_error_message(Error,&nELength,acError);
		printf("max_connect_cpu: %s\n",acError);
	}

	//read slot number of X-CAN-2 module
	Error = max_read_par_ushort(hCPUModule, CAN_TASK_NUMBER, CAN_PARAM_SLOT, &usSlot);
	if (usSlot != CANslot)
	{
		//set slot number of X-CAN-2 module
		Error = max_write_par_ushort(hCPUModule, CAN_TASK_NUMBER, CAN_PARAM_SLOT, CANslot);
	}

	//read parameters if interface 0
	usInSize = sizeof(CAN_INTERFACE_PARAMETERS);
	Error = max_read_par_block(hCPUModule, CAN_TASK_NUMBER, CAN_PARAM_INTERFACE0, &usInSize, &rcCanParams);
	usInSize = sizeof(CAN_INTERFACE_PARAMETERS);
	rcCanParams.ulFormat = 11 | 29;
	Error = max_write_par_block(hCPUModule, CAN_TASK_NUMBER, CAN_PARAM_INTERFACE0, &usInSize, &rcCanParams);

	//read parameters if interface 1
	usInSize = sizeof(CAN_INTERFACE_PARAMETERS);
	Error = max_read_par_block(hCPUModule, CAN_TASK_NUMBER, CAN_PARAM_INTERFACE1, &usInSize, &rcCanParams);
#ifdef ONE_INTERFACE
	rcCanParams.ulBitRate = 0; // disable interface 1
	usInSize = sizeof(CAN_INTERFACE_PARAMETERS);
	Error = max_write_par_block(hCPUModule, CAN_TASK_NUMBER, CAN_PARAM_INTERFACE1, &usInSize, &rcCanParams);
#endif

	//start interfaces
	Error = max_call_proc(hCPUModule, CAN_TASK_NUMBER, CAN_START_INTERFACES);
	if (Error != ERR_OK)
		max_clear_error();


	for (i=0; i<100; i++)
	{
		//send message on interafce 0
		rcWriteMsg.ulFormat		= 29;
		rcWriteMsg.ulId			  = 0x29;
		rcWriteMsg.ulDataSize	= 8;
		rcWriteMsg.aucData[0]	= 1;
		rcWriteMsg.aucData[1]	= 2;
		rcWriteMsg.aucData[2]	= 3;
		rcWriteMsg.aucData[3]	= 4;
		rcWriteMsg.aucData[4]	= 5;
		rcWriteMsg.aucData[5]	= 6;
		rcWriteMsg.aucData[6]	= 7;
		rcWriteMsg.aucData[7]	= 8;
		usInSize = 0;
		usOutSize = sizeof(rcWriteMsg);
		Error = max_call_func(hCPUModule, CAN_TASK_NUMBER, CAN_WRITE_INTERFACE0, 
			&usOutSize, &rcWriteMsg, &usInSize, arcReadMsg);
		if (Error != ERR_OK)
			max_clear_error();

		Sleep(100);

#ifndef ONE_INTERFACE
		//receive message on interface 1
		do
		{
			usInSize = sizeof(arcReadMsg);
			usOutSize = 0;
			Error = max_call_func(hCPUModule, CAN_TASK_NUMBER, CAN_READ_INTERFACE1, 
				&usOutSize, &rcWriteMsg, &usInSize, arcReadMsg);
			if (Error != ERR_OK)
				max_clear_error();
			if ((usInSize > 0) && (Error == ERR_OK))
			{
				for (usCount = 0; usCount < usInSize / sizeof(CAN_INTERFACE_READ); usCount++)
				{
					printf("(%0.8lu)CAN1: Id=%xh[%d] Data=",
						arcReadMsg[usCount].ulTimeStampLo, arcReadMsg[usCount].ulId, arcReadMsg[usCount].ulFormat);
					for (j=0; j<(int)arcReadMsg[usCount].ulDataSize; j++)
						printf("%0.2x ",arcReadMsg[usCount].aucData[j]);
					printf("\n");
				}
			}
		}while ((usInSize > 0) && (Error == ERR_OK));

		//now opposite direction:

		//send message on interafce 1
		rcWriteMsg.ulFormat		= 11;
		rcWriteMsg.ulId			  = 0x21;
		rcWriteMsg.ulDataSize	= 4;
		rcWriteMsg.aucData[0]	= 1;
		rcWriteMsg.aucData[1]	= 2;
		rcWriteMsg.aucData[2]	= 3;
		rcWriteMsg.aucData[3]	= 4;
		usInSize = 0;
		usOutSize = sizeof(rcWriteMsg);
		Error = max_call_func(hCPUModule, CAN_TASK_NUMBER, CAN_WRITE_INTERFACE1, 
			&usOutSize, &rcWriteMsg, &usInSize, arcReadMsg);
		if (Error != ERR_OK)
			max_clear_error();
		Sleep(100);
#endif

		//receive message on interface 0
		do
		{
			usInSize = sizeof(arcReadMsg);
			usOutSize = 0;
			Error = max_call_func(hCPUModule, CAN_TASK_NUMBER, CAN_READ_INTERFACE0, 
				&usOutSize, &rcWriteMsg, &usInSize, arcReadMsg);
			if (Error != ERR_OK)
				max_clear_error();
			if ((usInSize > 0) && (Error == ERR_OK))
			{
				for (usCount = 0; usCount < usInSize / sizeof(CAN_INTERFACE_READ); usCount++)
				{
					printf("(%0.8lu)CAN0: Id=%xh[%d] Data=",
						arcReadMsg[usCount].ulTimeStampLo, arcReadMsg[usCount].ulId, arcReadMsg[usCount].ulFormat);
					for (j=0; j<(int)arcReadMsg[usCount].ulDataSize; j++)
						printf("%0.2x ",arcReadMsg[usCount].aucData[j]);
					printf("\n");
				}
			}
		}while ((usInSize > 0) && (Error == ERR_OK));
	}

	//stop interfaces
	Error = max_call_proc(hCPUModule, CAN_TASK_NUMBER, CAN_STOP_INTERFACES);
	if (Error != ERR_OK)
		max_clear_error();

	//release CPU module
	max_clear_error();
	Error = max_exit_cpu(&hCPUModule);
	max_exit_lib();

 	return 0;
}
