/////////////////////////////////////////////////////////////////////////////
// XAD244Test.cpp 
// Board initialisation is done in this file,
// the variant of the X-AD24-4i is also detected
// Copyright SORCUS Computer GmbH 2005
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XAD244Test.h"
#include "XAD244TestDlg.h"
#include "SlotDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXAD244TestApp
/////////////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(CXAD244TestApp, CWinApp)
	//{{AFX_MSG_MAP(CXAD244TestApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXAD244TestApp constructor
/////////////////////////////////////////////////////////////////////////////
CXAD244TestApp::CXAD244TestApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The only CXAD244TestApp-Object
/////////////////////////////////////////////////////////////////////////////
CXAD244TestApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CXAD244TestApp Initialisation
/////////////////////////////////////////////////////////////////////////////
BOOL CXAD244TestApp::InitInstance()
{
	MAX_MODULINFO_TYPE	ModuleInfo;
	MAX_OS_INFO				OsInfo;
	MAXMODHND				hCpu;
	MAX_ERROR				Error;
	CString					strError;
	CSlotDialog				SlotDlg;
	CXAD244TestDlg			dlg;

	AfxEnableControlContainer();
#ifdef _AFXDLL
	Enable3dControls();
#else
	Enable3dControlsStatic();
#endif
	if (SlotDlg.DoModal()!=IDOK)
		return FALSE;
	if (max_init_lib(0)!=ERR_OK)
		return FALSE;
	if ((Error=max_get_module_info(SlotDlg.m_nCard, SlotDlg.m_nSlot, SlotDlg.m_nLayer, &ModuleInfo))!=ERR_OK)
	{
		AfxMessageBox(_T("No X-AD24-4i on selected slot"));
		return FALSE;
	}
	dlg.m_usSubType = ModuleInfo.usVariant;
    
    // get a handle for the CPU
	if (max_connect_cpu(SlotDlg.m_nCard, MAX_AUTO_SLOT, 0, &OsInfo, &hCpu)!=ERR_OK)
	{
		if (max_connect_cpu(SlotDlg.m_nCard, 0, 0, &OsInfo, &hCpu)!=ERR_OK)
		{
			AfxMessageBox(_T("No connection to cpu"));
			return FALSE;
		}
	}
	else 
    {   // for MAX6pci check active OsX on CPU-module and load full OsX if neccessary
        if (OsInfo.usType==MAX_MINI_OSX)
	    {
		    if (max_load_osx(hCpu, "ROM")!=ERR_OK)
		    {
			    AfxMessageBox(_T("Error on loading osx"));
			    return FALSE;
		    }
	    }
    }
    // load MDD for the X-AD24-4i
	if ((Error=max_load_mdd(hCpu, SlotDlg.m_nSlot, SlotDlg.m_nLayer, 0, 0x8014, NULL, &dlg.m_hMdd))!=ERR_OK)
	{
		strError.Format(_T("max_load_mdd: 0x%X"), Error);
		AfxMessageBox(strError);
		return FALSE;
	}
	m_pMainWnd = &dlg;
	dlg.DoModal();
	max_reset_mdd(dlg.m_hMdd);
	max_exit_cpu(&hCpu);
	max_exit_lib();
	return FALSE;
}
